
var temp_angle; // temporary angle used for the ring of fire
var number_of_flames = 0; // keeps track of the number of flames in order to get good frame rates


function effect_explo();
function particle_sparks();
function use_ring();
function fire_action();

function nRandom(n);

string fire_pcx = <fball_mod.pcx>;
string fire2_pcx = <magicr.mdl>;



define items skill30; 
define ring 8;

bmap spark_map = <fball_mod.pcx>; // for spark particles 

///////////////////////////////////////////////////////
//ring of fire from AUM script

function use_ring()
{
	player.items -= ring;
	while (1)
	{
		if (key_space == 1 && mouse_mode == 0 && number_of_flames == 0) // the mouse pointer is invisible and not too many entities are visible
		{
			temp_angle = 0;
			while (temp_angle < 360)
			{
				temp_angle += 3;
				temp.x = player.x + 100 * cos(temp_angle);
				temp.y = player.y + 100 * sin(temp_angle);
				temp.z = player.z;
				ent_create (fire_pcx, temp, fire_action);
                                ent_create (fire2_pcx, temp, fire_action);
                               
			}
		}
		while (key_space == 1) {wait (1);}
  		wait(1);
	}
}

function fire_action()
{
	number_of_flames += .75; // add another flame entity to this var
	my.passable = on;
	my.flare = on;
	my.bright = on;
	my.oriented = on;
	my.pan = random(360);
	while (my.pan < 1500)
	{
		my.pan += (5 + random(3)) * time;
		my.z += 0.4 * time;
                my.scale_x+=.04 * time;
                //my.lightrange-=4*time;  //trouble with lights
                //my.scale_y+=.04 * time; //z and y do cool stuff and no scale is cool too.
		wait (1);
	}
	number_of_flames -= .75;
	ent_remove (me);
}

///////////////////////////////////////////////////////////////////////
//simple particle script

function particle_sparks()
{
	temp.x = random(33) - 1;
	temp.y = random(22) - 1;
	temp.z = random(11) - 1.5;
	vec_add (my.vel_x, temp);
	my.alpha = 30 + random(50);
	my.bmap = spark_map;
	my.size = 5;
	my.flare = on;	
	my.bright = on;
	my.move = on;
	my.lifespan = 20;
	//my.function = fade_particle;
}


//////////////////////////////////////////////////////////////////////
// standard partical script

var tumblespeed[3] = 10,0,0;

BMAP spark_map1,<fireball2.tga>;  // changed to add my own sprite
bmap* scatter1_map = spark_map1;

// sets the vector to a random direction and length (max. range)
function vec_randomize(&vec,range)
{
vec[0] = random( 0 )-.5;
vec[1] = random( 5 )-.5;
vec[2] = random( 0 )*.5; // (abs(my.vel_x) + abs(my.vel_y)) * 3.3 + random(5) 
vec_normalize(vec,random(range));
}

// fades out a particle
function part_alphafade()
{
my.alpha +=  2 * time; // positive number no fading hard edges
my.vel_x == my.vel_x * .05;
my.vel_y == my.vel_y * .05;
if (my.alpha <= 0) { my.lifespan = 0; }
}

var dir;

function effect_explo()
{
dir= nRandom(dir*sin(player.pan-100))+50;
vec_randomize(temp,dir );
vec_add(my.vel_x,temp);
my.lightgreen  = 250;
my.lightrange = 4000;
MY_SPEED.X = RANDOM(2)-1;
my.lifespan =  1;
my.gravity =  2 ;
my.bmap = scatter1_map;
my.flare = on;
my.bright = on;
my.size =  16;
my.streak = on;
my.beam = on;
my.move = on;
my.lifespan =  1;
//  my.function = NULL;
my.function = part_alphafade;
}


action explode
{
while(1)
{
vec_scale(normal,2);
effect(effect_explo, 12 ,my.x,normal);
wait(1);
}
remove(me);
}



///////////////////////////////////////////////////////////////////
//true random script from A5 forum

function nRandom(n)
{
	var xRandom;
	var yRandom;
	xRandom = random(n);
	yRandom = random(1);

	if(yRandom <= 0.5)
	{
		xRandom = (xRandom * -1);
		return(xRandom);
	}
	else
	{
		return(xRandom);
	}
}


